{assign var="page_title" value="##Advanced Settings##"}
{include file="admin/header.inc.tpl"}

<h1>{$page_title|escape}</h1>

{show_errors}
{start_form}
<fieldset class="settings">
  <legend>##Server settings##</legend>
  <div class="settings-row">
    <div class="settings-left">
      ##Local timezone:##<br />
    </div>
    <div class="settings-right">
      {html_options name="server[timezone]" options=$timezones selected=$app->settings->server->timezone}
    </div>
  </div>

  <div class="settings-row">
    <div class="settings-left">
      ##Current timezone date/time##: 
    </div>
      <div class="settings-right-string">{$smarty.now|date_format:"%Y/%m/%d %H:%M:%S"}</div>
  </div>
  <div class="clear"></div>
</fieldset>
<p><input class="button" type="submit" value="##Save##" /></p>

<fieldset class="settings">
  <legend>##Grids advanced settings##</legend>
  <div class="settings-row">
    <div class="settings-left">##Region Approval Required?##</div>
    <div class="settings-right">
      {html_yesno name="grids[approval_required]" default=$app->setting->approval_required value=$app->settings->grids->approval_required}
    </div>
    <div class="clear"></div>
  </div>

  <div class="settings-row">
    <div class="settings-left">##Require approval after user update?##</div>
    <div class="settings-right">
      {html_yesno name="grids[approval_user_update]" value=$app->settings->grids->approval_user_update}
    </div>
  </div>

  <div class="settings-row">
    <div class="settings-left">##Allow user delete own regions?##</div>
    <div class="settings-right">
      {html_yesno name="regions[user_delete]" value=$app->settings->regions->user_delete}
    </div>
  </div>

  <div class="settings-row">
    <div class="settings-left">##Disable tooltip image?##</div>
    <div class="settings-right">
      {html_yesno name="regions[tooltip_image]" value=$app->settings->regions->tooltip_image}
    </div>
  </div>

  <div class="settings-row">
    <div class="settings-left">
      ##Allow region description?##<br />
    </div>
    <div class="settings-right">
      {html_yesno name="regions[description]" default=$app->settings->regions->description value=$app->settings->regions->description} - <i>##Will be used for region page##</i>
    </div>
    <div class="clear"></div>
  </div>

  <div class="settings-row">
    <div class="settings-left">
      ##Enable page per region?##<br />
    </div>
    <div class="settings-right">
      {html_yesno name="regions[region_page]" default=$app->settings->regions->region_page value=$app->settings->regions->region_page} - <i>##Region links will point to interlan own pages##</i>
    </div>
    <div class="clear"></div>
  </div>

  <div class="settings-row">
    <div class="settings-left">
      ##Enable page per user?##<br />
    </div>
    <div class="settings-right">
      {html_yesno name="users[user_page]" default=$app->settings->users->user_page value=$app->settings->users->user_page} - <i>##Enable personal user page functionality##</i>
    </div>
    <div class="clear"></div>
  </div>

  <div class="settings-row">
    <div class="settings-left">
      ##Disable region link on region page?##<br />
    </div>
    <div class="settings-right">
      {html_yesno name="region_page[link]" default=$app->settings->region_page->link value=$app->settings->region_page->link} - <i>##Disable links to site on region pages##</i>
    </div>
    <div class="clear"></div>
  </div>

  <div class="settings-row">
    <div class="settings-left">
      ##Enable cancel button?##<br />
    </div>
    <div class="settings-right">
      {html_yesno name="get_pixels[cancel]" default=$app->settings->get_pixels->cancel value=$app->settings->get_pixels->cancel} - <i>##Add cancel button to all "Get Pixels" steps##</i>
    </div>
    <div class="clear"></div>
  </div>
</fieldset>
<p><input class="button" type="submit" value="##Save##" /></p>

<fieldset class="settings">
  <legend>##'Meta tags' settings##</legend>
  <i>##See <a target="_blank" href="http://www.w3.org/TR/html4/struct/global.html#h-7.4.4">w3c documentation</a> if you need more information about these options##.</i>
  <div class="settings-row">
    <table width="100%">
      <tr>
        <td class="table-settings-left">##Robots:##</td>
        <td><textarea class="admin-wide-textarea" name="meta_tags[robots]">{$app->settings->meta_tags->robots|default:"index, follow"}</textarea>
</td>
      </tr>
    </table>
  </div>

  <div class="settings-row">
    <table width="100%">
      <tr>
        <td class="table-settings-left">##Keywords:##</td>
        <td><textarea class="admin-wide-textarea" name="meta_tags[keywords]">{$app->settings->meta_tags->keywords|default:"million pixel script, pixel script, pixel ad script, millionpixel script, pixelscript, pixelscripts, millionpixel, million script, php pixel script, pixelotto, pixel lotto, pixel lotto script, million pixel software, php millionpixel script, php million pixel, cgi million pixel, million dollar php script, million dollar homepage script, million dollar homepage, pixelflachen, online, option, dollar, free, homepage, texmedia, million, script, pixel, million pixel, version, script million, php, MillionDollarHomePage.com, million pixel ads, script million pixel, Alex Tew, milliondollarscript, million dollar script, free pixel ads, pixel advertising, pixel, selling pixels, million dollar"}</textarea></td>
      </tr>
    </table>
  </div>  

  <div class="settings-row">
    <table width="100%">
      <tr>
        <td class="table-settings-left">##Description##:</td>
        <td><textarea class="admin-wide-textarea" name="meta_tags[description]">{$app->settings->meta_tags->description|default:"GPix is a FREE yet powerful million pixel script"}</textarea></td>
      </tr>
    </table>
  </div>

  <div class="settings-row">
    <table width="100%">
      <tr>
        <td class="table-settings-left">##Copyright##:</td>
        <td><textarea class="admin-wide-textarea" name="meta_tags[copyright]">{$app->settings->meta_tags->copyright|default:"Darren G. Gates"}</textarea></td>
      </tr>
    </table>
  </div>

  <div class="settings-row">
    <table width="100%">
      <tr>
        <td class="table-settings-left">##Author##:</td>
        <td><textarea class="admin-wide-textarea" name="meta_tags[author]">{$app->settings->meta_tags->author|default:"Alexandr D. Kosarev <gpix@kalexandr.com>"}</textarea></td>
      </tr>
    </table>
  </div>
  
</fieldset>
<p><input class="button" type="submit" value="##Save##" /></p>
<fieldset class="settings">
  <legend>##Discounts settings##</legend>
  <div class="settings-row">
    <div class="settings-left">
      ##Discounts:##<br />
    </div>
    <div class="settings-right">
      {html_yesno name="discounts[enabled]" default=$app->settings->discounts->enabled value=$app->settings->discounts->enabled}
    </div>
  </div>

  <div class="settings-row">
    <div class="settings-left">
      ##Discount percent##: <br />
      <i>##100% for free##</i>
    </div>
      <div class="settings-right-string"><input name="discounts[percent]" value="{$app->settings->discounts->percent}" />% </div>
  </div>
  <div class="clear"></div>
</fieldset>
<p><input class="button" type="submit" value="##Save##" /></p>

<fieldset class="settings">
  <legend>##Categories settings##</legend>
  <div class="settings-row">
    <div class="settings-left">
      ##Enable categories for grids:##<br />
    </div>
    <div class="settings-right">
      {html_yesno name="categories[grids]" default=$app->settings->categories->grids value=$app->settings->categories->grids}
    </div>
  </div>

  <div class="settings-row">
    <div class="settings-left">
      ##Enable categories for regions:##<br />
    </div>
    <div class="settings-right">
      {html_yesno name="categories[regions]" default=$app->settings->categories->regions value=$app->settings->categories->regions}
    </div>
  </div>
  <div class="clear"></div>

  <div class="settings-row">
    <div class="settings-left">
      ##Use regions categories <br />as filter for grid:##<br />
    </div>
    <div class="settings-right">
      {html_yesno name="categories[regions_grid_filter]" default=$app->settings->categories->regions_grid_filter value=$app->settings->categories->regions_grid_filter}
    </div>
  </div>
  <div class="clear"></div>
</fieldset>
<p><input class="button" type="submit" value="##Save##" /></p>

{end_form}

{include file="admin/footer.inc.tpl"}
